from .test import *
from .plot import *
from .geom import *
from collections import deque

def divide(polygon):
    sub = []

    for x in polygon:
        p = middle(x.point, x.next().point)
        sub.append(p)

    return Polygon(sub)

def main():
    figures = deque()

    figures.append(Polygon([(-1, -1), (1, -1), (1, 1), (-1, 1)]))

    for _ in range(1, 100):
        curr = figures.popleft()

        for pol in polygon_reconstruction(polygon_difference(curr, divide(curr))):
            figures.append(pol)

    for x in figures:
        plot_polygon(x)

    show_all()
